我看到了这段代码 https://leetcode.com/discuss/37282/simple-python-recursive-solution-bfs-o-n-80ms
这是
的答案给定二叉树,找到它的最小深度。
最小深度是沿最短路径的节点数 根
节点向下到最近的叶节点。
class Solution:
# @param {TreeNode} root
# @return {integer}
def minDepth(self, root):
if not root:
return 0
nodes = [(root, 1)]
while nodes:
node, curDepth = nodes.pop(0)
if node.left is None and node.right is None:
return curDepth
if node.left:
nodes.append((node.left, curDepth + 1))
if node.right:
nodes.append((node.right, curDepth + 1))
所以我的困惑是,节点1是否有节点2和节点3作为其.left和.right子节点,因此堆栈将是[(节点2,someDepth),(节点3 someDepth)]。然后,由于堆栈将仅弹出列表的最后一个元素,然后(节点3 someDepth)将被解包,而节点2被完全忽略。那么,如果节点2没有子节点,而节点3有,那么使用节点3进行后续迭代是不是错了?
答案 0 :(得分:5)
你缺少的是
nodes.pop(0)
弹出第0个元素。
所以你错了:
然后由于堆栈只会弹出列表的最后一个元素,然后......
想象一下二叉树:
1
/ \
2 3
/ \ / \
4 5 6 7
/ \ / \ /
8 9 10 11 12
此处状态空间将更改为(为简单起见,节点被命名为其内容编号):
# Before 1st iteration.
nodes = [(1, 1)]
# 1st iteration.
node, curDepth = 1, 1
nodes = [(2, 2), (3, 2)]
# 2nd iteration.
node, curDepth = 2, 2
nodes = [(3, 2), (4, 3), (5, 3)]
# 3rd iteration.
node, curDepth = 3, 2
nodes = [(4, 3), (5, 3), (6, 3), (7, 3)]
# 4th iteration.
node, curDepth = 4, 3
nodes = [(5, 3), (6, 3), (7, 3), (8, 4), (9, 4)]
# 5th iteration.
node, curDepth = 5, 3
# Here if node.left is None and node.right is None becomes True and curDepth i.e. 3 is returned.
可以看出,节点是明智的(树的)宽度,因此它是BFS。
答案 1 :(得分:0)
递归解决方案更容易理解。
DSUM